

   MEMBER('tickets.clw')                              ! This is a MEMBER module

                     MAP
                       INCLUDE('TICKE005.INC'),ONCE        !Local module procedure declarations
                     END


mLanguage   BYTE,AUTO
Num2Words            PROCEDURE  (PassedAm, DollarsFlag) ! Declare Procedure
AmtString            CSTRING(500),AUTO
Cents                BYTE,AUTO
Ndx                  BYTE,AUTO
NdxTarget            BYTE,AUTO
LoopCount            BYTE,AUTO
IntLen               BYTE,AUTO
eSize                Equate(21)                      !Number of Digits that this function can handle (Needs to be a multiple of 3)
IntAm                CString(eSize+1)                !A String to hold the passed digits so they may be easily parsed
  CODE
 SET (Config_File)
 NEXT(Config_File)

 CASE UPPER(CLIP(CNF:Country))
   OF 'MEXICO'; mLanguage = 1      ! Spanish
   OF 'PARIS' ; mLanguage = 2      ! French
 ELSE;          mLanguage = False  ! English
 END

 IntLen = LEN(CLIP(FORMAT(INT(PassedAm),@s30)))

 IF IntLen > eSize; RETURN('Too Many Digits (' & IntLen & ') The limit is Decimal(23,2).').

 LoopCount = 0                                     !Initialize the LoopCount (just in case)
 IntAm     = INT(PassedAm)                         !Save the stuff to the left side of the decimal point
 IntLen    = LEN(IntAm)                            !Save the number of integer digits (used for padding zeros and determining the number of loops)
 IntAm     = ALL('0', eSize-IntLen) & IntAm        !Shove everything to the right
 Cents     = (PassedAm - Int(PassedAm)) * 100      !Save the cents
 NdxTarget = (eSize-IntLen)                        !Calculate the number of iterations
 IF NdxTarget < 3; NdxTarget = 3.                  !Fix it to 3 if lower (to avoid string slicing problems)

 LOOP Ndx  = eSize to NdxTarget by -3              !Process the digits from the right to the left in groups of 3.
    LoopCount += 1                                  !Determines if we are on hundreds, thousands, millions, etc..
    AmtString = TranslateGroup(IntAm[Ndx-2 : Ndx],LoopCount) & AmtString !Prepend the current text to the return string
 END

 CASE mLanguage
   OF 0; AmtString = AmtString & |
                     CHOOSE(AmtString ~= '','and ','') & |
                     CHOOSE(~Cents,'NO',FORMAT(Cents,@n2)) & '/100' & |
                     CHOOSE(DollarsFlag,' DOLLARS','') !Finalize the string before returning.

   OF 1; AmtString = CLIP(AmtString) & ' ' & |
                     FORMAT(Cents,@n02) & '/100' & |
                     CHOOSE(DollarsFlag,' PESOS','') !Finalize the string before returning.
   OF 2; AmtString = AmtString & |
                     CHOOSE(AmtString ~= '','et ','') & |
                     FORMAT(Cents,@n02) & '/100' & |
                     CHOOSE(DollarsFlag,' FRANCS','') !Finalize the string before returning.
 END

 RETURN(AmtString)
GetOnes              PROCEDURE  (Ones)                ! Declare Procedure
  CODE
 CASE mLanguage
   OF 0; RETURN CHOOSE(Ones,' ONE',' TWO',' THREE',' FOUR',  ' FIVE', ' SIX', ' SEVEN',' EIGHT',' NINE','')
   OF 1; RETURN CHOOSE(Ones,' UNO',' DOS',' TRES', ' CUATRO',' CINCO',' SEIS',' SIETE',' OCHO', ' NUEVE','')
   OF 2; RETURN CHOOSE(Ones,' UN',' DEUX',' TROIS', ' QUATRE',' CINQ',' SIX',' SEPT',' HUIT', ' NEUF','')
 END

TranslateGroup       PROCEDURE  (PassedGr, Sequence)  ! Declare Procedure
ReturnString         CSTRING(80)
Tens                 BYTE
  CODE
 CLEAR(ReturnString)

 Tens = Int(PassedGr[2 : 3])                         !Take the last 2 digits for evaluation

 CASE mLanguage
   OF 0          !English
      CASE Tens
        OF  0 TO  9;       ReturnString = GetOnes(Tens)
        OF 10 TO 19;       ReturnString = CHOOSE(Tens - 9,           ' TEN',   ' ELEVEN',' TWELVE',' THIRTEEN',' FOURTEEN',' FIFTEEN',' SIXTEEN',' SEVENTEEN',' EIGHTEEN',' NINETEEN','')
        OF 20 TO 99;       ReturnString = CHOOSE(Int(PassedGr[2]),'',' TWENTY',' THIRTY',' FORTY', ' FIFTY',   ' SIXTY',   ' SEVENTY',' EIGHTY', ' NINETY','') & |
                                          GetOnes(Int(PassedGr[3]))
       END

      IF INT(PassedGr[1]); ReturnString = GetOnes(Int(PassedGr[1])) & ' HUNDRED' & ReturnString.

      IF ReturnString;     ReturnString = ReturnString &  CHOOSE(Sequence, '', ' THOUSAND',' MILLION',' BILLION',' TRILLION',' QUADRILLION',' QUINTILLION').
    OF 1      !Spanish
      CASE Tens
        OF  0 TO  9;       ReturnString = GetOnes(Tens)
        OF 10 TO 19;       ReturnString = CHOOSE(Tens - 9,           ' DIEZ',  ' ONCE',   ' DOCE',    ' TRECE',    ' CATORCE',' QUINCE', ' DIEZ Y SEIS',' DIEZ Y SIETE',' DIEZ Y OCHO',' DIEZ Y NUEVE','')
        OF 20 TO 29;       ReturnString = ' VEINTI' & LEFT(GetOnes(Int(PassedGr[3])))
        OF 30 TO 99;       ReturnString = CHOOSE(Int(PassedGr[2]),'','',' TREINTA',' CUARENTA',' CINCUENTA',' SESENTA',' SETENTA',' OCHENTA',    ' NOVENTA','') & |
                                          CHOOSE(GetOnes(Int(PassedGr[3])) ~= '', ' Y', '') & |
                                                 GetOnes(Int(PassedGr[3]))
      END

      IF INT(PassedGr[1]); ReturnString = CHOOSE(Int(PassedGr[1]) > 1, GetOnes(Int(PassedGr[1])) & ' CIENTOS', 'CIENTO') & ReturnString.

      IF ReturnString;     ReturnString = ReturnString &  CHOOSE(Sequence, '', ' MIL',' UN MILLON',' BILLION',' TRILLION',' QUADRILLION',' QUINTILLION').
   OF 2          !French
      CASE Tens
        OF  0 TO  9;       ReturnString = GetOnes(Tens)
        OF 10 TO 19;       ReturnString = CHOOSE(Tens - 9,           ' DIX',   ' ONZE',' DOUZE',' TREIZE',' QUATORZE',' QUINZE',' SEIZE',' DIX-SEPT',' DIX-HUIT',' DIX-NEUF','')
        OF 20 TO 99;       ReturnString = CHOOSE(Int(PassedGr[2]),'',' VINGT',' TRENTE',' QUARANTE', ' CINQUANTE',   ' SOIXANTE',   ' SOIXANTE-DIX',' QUATRE-VINGT', ' QUATRE-VINGT-DIX','') & |
                                          GetOnes(Int(PassedGr[3]))
       END

      IF INT(PassedGr[1]); ReturnString = GetOnes(Int(PassedGr[1])) & ' CENT' & ReturnString.

      IF ReturnString;     ReturnString = ReturnString &  CHOOSE(Sequence, '', ' MILLE',' MILLION',' MILLIARD',' TRILLION',' QUADRILLION',' QUINTILLION').
 END

 Return(Left(ReturnString))
